// Generated by CoffeeScript 1.7.1
var mohair, q, _,
  __slice = [].slice;

mohair = require('mohair');

q = require('q');

_ = require('underscore');

module.exports = {
  clone: function() {
    return Object.create(this);
  },
  fluent: function(key, value) {
    var object;
    object = this.clone();
    object[key] = value;
    return object;
  },
  $mohair: mohair.escape(function(string) {
    return "\"" + string + "\"";
  }),
  $returning: '*',
  $primaryKey: 'id',
  $allowedColumns: [],
  $returnFirst: false,
  returning: function(arg) {
    return this.fluent('$returning', arg);
  },
  connection: function(arg) {
    return this.fluent('$connection', arg);
  },
  allowedColumns: function(columns) {
    return this.fluent('$allowedColumns', this.$allowedColumns.concat(columns));
  },
  primaryKey: function(arg) {
    return this.fluent('$primaryKey', arg);
  },
  table: function(arg) {
    return this.fluent('$table', arg).fluent('$mohair', this.$mohair.table(arg));
  },
  returnFirst: function(arg) {
    if (arg == null) {
      arg = true;
    }
    return this.fluent('$returnFirst', arg);
  },
  debug: function(arg) {
    return this.fluent('$debug', arg);
  },
  $beforeInsert: [],
  $afterInsert: [],
  $beforeUpdate: [],
  $afterUpdate: [],
  $afterSelect: [],
  $afterDelete: [],
  beforeInsert: function() {
    var args;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    return this.fluent('$beforeInsert', this.$beforeInsert.concat(args));
  },
  afterInsert: function() {
    var args;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    return this.fluent('$afterInsert', this.$afterInsert.concat(args));
  },
  beforeUpdate: function() {
    var args;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    return this.fluent('$beforeUpdate', this.$beforeUpdate.concat(args));
  },
  afterUpdate: function() {
    var args;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    return this.fluent('$afterUpdate', this.$afterUpdate.concat(args));
  },
  afterDelete: function() {
    var args;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    return this.fluent('$afterUpdate', this.$afterUpdate.concat(args));
  },
  afterSelect: function() {
    var args;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    return this.fluent('$afterSelect', this.$afterSelect.concat(args));
  },
  runPipeline: function(pipeline, data) {
    var reducer;
    reducer = function(soFar, f) {
      return soFar.then(f);
    };
    return pipeline.reduce(reducer, q(data));
  },
  sql: function() {
    return this.replacePlaceholders(this.$mohair.sql());
  },
  params: function() {
    return this.$mohair.params();
  },
  raw: function() {
    var args, _ref;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    return (_ref = this.$mohair).raw.apply(_ref, args);
  },
  where: function() {
    var args, _ref;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    return this.fluent('$mohair', (_ref = this.$mohair).where.apply(_ref, args));
  },
  join: function() {
    var args, _ref;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    return this.fluent('$mohair', (_ref = this.$mohair).join.apply(_ref, args));
  },
  select: function() {
    var args, _ref;
    args = 1 <= arguments.length ? __slice.call(arguments, 0) : [];
    return this.fluent('$mohair', (_ref = this.$mohair).select.apply(_ref, args));
  },
  limit: function(arg) {
    return this.fluent('$mohair', this.$mohair.limit(arg));
  },
  offset: function(arg) {
    return this.fluent('$mohair', this.$mohair.offset(arg));
  },
  order: function(arg) {
    return this.fluent('$mohair', this.$mohair.order(arg));
  },
  group: function(arg) {
    return this.fluent('$mohair', this.$mohair.group(arg));
  },
  "with": function(arg) {
    return this.fluent('$mohair', this.$mohair["with"](arg));
  },
  getConnection: function(cb) {
    var self;
    self = this;
    if (self.$connection == null) {
      throw new Error("the method you are calling requires a call to connection() before it");
    }
    if ('function' === typeof self.$connection) {
      self.$connection(cb);
      return;
    }
    return setTimeout(function() {
      return cb(null, self.$connection);
    });
  },
  query: function(sql, params) {
    var d, self;
    self = this;
    self.$debug('MESA', 'QUERY', sql, params) != null;
    d = q.defer();
    self.getConnection(function(err, connection, done) {
      if (err != null) {
        done() != null;
        d.reject(err);
        return;
      }
      return connection.query(sql, params, function(err, results) {
        done() != null;
        if (err != null) {
          d.reject(err);
          return;
        }
        return d.resolve(results);
      });
    });
    return d.promise;
  },
  insert: function(dataOrArray) {
    var array, self;
    self = this;
    array = Array.isArray(dataOrArray) ? dataOrArray : [dataOrArray];
    return self.returnFirst().insertMany(array);
  },
  insertMany: function(array) {
    var beforeInsert, self;
    self = this;
    beforeInsert = function(data) {
      return self.runPipeline(self.$beforeInsert, data);
    };
    return q.all(array.map(beforeInsert)).then(function(processedArray) {
      var cleanArray, query, sql;
      cleanArray = processedArray.map(function(data) {
        return self.pickAllowedColumns(data);
      });
      cleanArray.forEach(function(cleanData) {
        if (Object.keys(cleanData).length === 0) {
          return q.reject(new Error('nothing to insert'));
        }
      });
      query = self.$mohair.insertMany(cleanArray);
      sql = self.appendReturning(self.replacePlaceholders(query.sql()));
      return self.query(sql, query.params()).then(function(results) {
        return self.afterQuery(self.$afterInsert, results);
      });
    });
  },
  update: function(data) {
    var self;
    self = this;
    return self.runPipeline(self.$beforeUpdate, data).then(function(processedData) {
      var cleanData, query, sql;
      cleanData = self.pickAllowedColumns(processedData);
      if (Object.keys(cleanData).length === 0) {
        return q.reject(new Error('nothing to update'));
      }
      query = self.$mohair.update(cleanData);
      sql = self.appendReturning(self.replacePlaceholders(query.sql()));
      return self.query(sql, query.params()).then(function(results) {
        return self.afterQuery(self.$afterUpdate, results);
      });
    });
  },
  "delete": function() {
    var query, self, sql;
    self = this;
    query = self.$mohair["delete"]();
    sql = self.appendReturning(self.replacePlaceholders(query.sql()));
    return self.query(sql, query.params()).then(function(results) {
      return self.afterQuery(self.$afterDelete, results);
    });
  },
  find: function() {
    var self;
    self = this;
    return self.query(self.sql(), self.params()).then(function(results) {
      return self.afterQuery(self.$afterSelect, results);
    });
  },
  exists: function() {
    var self;
    self = this;
    return self.query(self.sql(), self.params()).then(function(results) {
      return (results.rows != null) && results.rows.length !== 0;
    });
  },
  first: function() {
    return this.limit(1).returnFirst().find();
  },
  replacePlaceholders: function(sql) {
    var index;
    index = 1;
    return sql.replace(/\?/g, function() {
      return '$' + index++;
    });
  },
  pickAllowedColumns: function(data) {
    var self;
    self = this;
    return _.pick(data, self.$allowedColumns);
  },
  afterQuery: function(pipeline, results) {
    var processRow, self;
    self = this;
    if (results.rows != null) {
      processRow = function(row) {
        return self.runPipeline(pipeline, row);
      };
      return q.all(results.rows.map(processRow)).then(function(processedRows) {
        if (self.$returnFirst) {
          return processedRows[0];
        } else {
          return processedRows;
        }
      });
    } else {
      return results;
    }
  },
  appendReturning: function(sql) {
    var self;
    self = this;
    if (self.$returning != null) {
      return sql + ' RETURNING ' + self.$returning;
    } else {
      return sql;
    }
  }
};
